# TCP Socket client 
 
import socket
import time
import sys
import argparse

def readFromFile(sFile):
    file = open(sFile, "r")
    content = file.read()
    # Close the file
    file.close()
    return content

def main(remote_ip, port,file=None):
    host = ''
     
    # create socket
    print('# Creating socket')
    try:
        sk = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    except socket.error:
        print('Failed to create socket')
        sys.exit()
          
    print('# Getting remote IP address') 
    try:
        if remote_ip == None:
            remote_ip = socket.gethostbyname( host )
    except socket.gaierror:
        print('Hostname could not be resolved. Exiting')
        sys.exit()
     
    # Connect to remote server
    print('# Connecting to server, ' + host + ' (' + remote_ip + ':' + str(port) + ')')
    sk.connect((remote_ip , port))
    sk.settimeout(0.5)
    #sk.setblocking(0)
     
    recvbuflen=1024
    recvbuf=[]
    msg=[]
    #try:
    while True:
        request=input("?")
        if file != None:
            request = readFromFile(file)
        else:
            request=input("?")
        print(request)
        try:
            sk.sendall((request+'\n').encode('utf-8'))
            print("sent")
            break
            recvbuf = sk.recv(recvbuflen)
            if len(recvbuf)>0:
                print('# Receive data from server')
                sys.stdout.write("[%d]%s\n" % (len(recvbuf), recvbuf))
                if recvbuf.upper()=='CLOSE':
                    sk.close()
                    del sk
                    sk = None
                    break
            else:
               break
        except socket.timeout:
            pass
        except socket.error as ex:
            print ('Error: ' + str(ex))
            sys.exit()

if __name__ == "__main__":
    parser = argparse.ArgumentParser()#127.0.0.1

    parser.add_argument("--ip", type=str, default="192.168.1.54",
                        help="Remote ip address [%(default)s]")
    parser.add_argument("--port", type=int, default=80,
                        help="Remote port number [%(default)s]")
    parser.add_argument("--file", type=str, default=None,
                        help="File to Send")
    args = parser.parse_args()
    main(args.ip, args.port, args.file)
